//
// Generated stub from file:/buildfactory/kundo/hudson/jobs/Release-Kundo_Plug-ins/workspace/plugins/target/checkout/plugins/kundo-reactor-plugin/src/main/groovy/org/openscm/kundo/strategy/ModuleStrategy.groovy
//

package org.openscm.kundo.strategy;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import groovy.lang.*;
import groovy.util.*;
import org.openscm.kundo.common.logging.SimpleLogger;
import org.openscm.kundo.plugins.Module;

/**
 * Module Strategy
 *
 * @author <a href="mailto:nigel.garner@upco.co.uk">Nigel Garner</a>
 * @version 1.0.0

Description: An abstraction of the module strategy.

<p>Abstract module strategy to act as a parent to all concrete implementations of the pattern.</p>
 */
public abstract class ModuleStrategy
    extends java.lang.Object
{
    /**
     * List of Modules to be processed*
     */
    protected List modules = null;

    /**
     * Logger instance *
     */
    protected final SimpleLogger log = null;

    /**
     * AntBuilder instace *
     */
    protected AntBuilder ant = null;

    private ModuleStrategy(java.lang.Void void1, java.lang.Void void2, java.lang.Void void3) {
        throw new InternalError("Stubbed method");
    }

    /**
     * Constructor sets ant instance
     *
     * @param ant AntBuilder instance
     */
    public ModuleStrategy(java.lang.Object ant) {
        this((java.lang.Void)null, (java.lang.Void)null, (java.lang.Void)null);
        throw new InternalError("Stubbed method");
    }

    /**
     * Abstract method where delegates should perform the module loading
     *
     * @param buildContext The global ant project
     * @param childTarget The ant target to call on child modules
     * @param inheritConfiguration Whether the sub module should inherit the properties of the parent project
     * @param profiles A list of profiles to be loaded in the search for modules
     */
    abstract public void loadModules(java.lang.Object buildContext, java.lang.Object childBuildFile, java.lang.Object childTarget, java.lang.Object inheritConfiguration, java.lang.Object profiles);

    public groovy.lang.MetaClass getMetaClass() {
        throw new InternalError("Stubbed method");
    }

    public void setMetaClass(groovy.lang.MetaClass metaClass) {
        throw new InternalError("Stubbed method");
    }

    public java.lang.Object invokeMethod(java.lang.String name, java.lang.Object args) {
        throw new InternalError("Stubbed method");
    }

    public java.lang.Object getProperty(java.lang.String name) {
        throw new InternalError("Stubbed method");
    }

    public void setProperty(java.lang.String name, java.lang.Object value) {
        throw new InternalError("Stubbed method");
    }
}
