//
// Generated stub from file:/buildfactory/kundo/hudson/jobs/Release-Kundo_Plug-ins/workspace/plugins/target/checkout/plugins/kundo-reactor-plugin/src/main/groovy/org/openscm/kundo/strategy/EclipseModuleStrategy.groovy
//

package org.openscm.kundo.strategy;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import groovy.lang.*;
import groovy.util.*;
import org.openscm.kundo.plugins.Module;
import org.openscm.kundo.common.PropertyUtils;
import org.apache.tools.ant.BuildException;

/**
 * Eclipse Module Strategy
 *
 * @author <a href="mailto:ben.leedham@upco.co.uk">Ben Leedham</a>
 * @version 1.0.0

Description: The Eclipse Module Strategy loads a list of modules based an eclipse project set file.

<p>The Eclipse Module Strategy creates a list of modules based on the eclipse team project set file.
The project set file is parsed by using ant4eclipse ant tasks to obtain the build order, this build order
is then executed as separate ant builds.

The eclipse project set file points to projects in your eclipse workspace, therefore Kundo needs to know
the location of the eclipse workspace. It is necessary for this property to be externalised to allow the
build to be run in different environments, to work with the eclipse strategy you must specify the
ECLIPSE_WORKSPACE_LOCATION environment variable and point it to the eclipse workspace directory.</p>
 */
public class EclipseModuleStrategy
    extends ModuleStrategy
{
    private java.lang.Object workspace = null;
    public java.lang.Object getWorkspace() {
        throw new InternalError("Stubbed method");
    }
    public void setWorkspace(java.lang.Object value) {
        throw new InternalError("Stubbed method");
    }

    private EclipseModuleStrategy(java.lang.Void void1, java.lang.Void void2, java.lang.Void void3) {
        super((java.lang.Object)null);

        throw new InternalError("Stubbed method");
    }

    /**
     * Constructor passes the ant instance in a call to super
     *
     * @param ant AntBuilder instance
     */
    public EclipseModuleStrategy(java.lang.Object ant) {
        this((java.lang.Void)null, (java.lang.Void)null, (java.lang.Void)null);
        throw new InternalError("Stubbed method");
    }

    /**
     * Setter method for member variable workspace
     *
     * @param workspace String representation of the workspace location
     */
    public void setWorkspace(java.lang.String workspace) {
        throw new InternalError("Stubbed method");
    }

    /**
     * Concrete implementation of the ModuleStrategy.loadModules() method
     * 
     * Loads a list of modules based upon the eclipse projects team project set file. The project set file is obtained through the
     * ECLIPSE_WORKSPACE_LOCATION environment variable, or searching a path relative to the project.
     */
    public void loadModules(java.lang.Object buildContext, java.lang.Object childBuildFile, java.lang.Object childTarget, java.lang.Object inheritConfiguration, java.lang.Object profiles) {
        throw new InternalError("Stubbed method");
    }

    /**
     * Method to find the workspace location, currently searches for an environment variable if that doesn't exist
     * it looks in the current projects parent directory for a directory named .metadata if neither can be found
     * then a MissingPropertyException will be thrown.
     *
     * @param projectDir String representation of the current project's directory
     * @return String representation of the workspace containing the current projject and it's referenced projects
     * @throws MissingPropertyException if no workspace location can be identified
     */
    public java.lang.String findWorkspace(java.lang.String projectDir) {
        throw new InternalError("Stubbed method");
    }

    public groovy.lang.MetaClass getMetaClass() {
        throw new InternalError("Stubbed method");
    }

    public void setMetaClass(groovy.lang.MetaClass metaClass) {
        throw new InternalError("Stubbed method");
    }

    public java.lang.Object invokeMethod(java.lang.String name, java.lang.Object args) {
        throw new InternalError("Stubbed method");
    }

    public java.lang.Object getProperty(java.lang.String name) {
        throw new InternalError("Stubbed method");
    }

    public void setProperty(java.lang.String name, java.lang.Object value) {
        throw new InternalError("Stubbed method");
    }
}
